
import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import lotus.domino.*;
import org.eclipse.draw2d.geometry.Point;

import java.util.*;



/**
 * A test class to display a UMLFigure
 */
public class ChainDetector {	
		
 public static void main(String args[]){
	 
	 Database myDb = null;
	 
	 try
     {
         NotesThread.sinitThread();
         Session s = NotesFactory.createSession();
         
         String db_name = "<Unknown>";
         if (args.length>0) db_name = args[0];
                  
         myDb = s.getDatabase("", db_name);                  
         
         System.out.println(s.getUserName());
     
         DxlExporter exporter = s.createDxlExporter();
         
      // Create note collection
         /*
         NoteCollection nc = myDb.createNoteCollection(false);
         nc.selectAllDesignElements(true);
         nc.selectAllCodeElements(true);
         nc.selectAllFormatElements(true);
         nc.selectAllIndexElements(false);
         nc.selectAllAdminNotes(false);
         nc.buildCollection();
         */
         
         
         DatabaseNameExtractor dbnamex = new DatabaseNameExtractor(exporter.exportDxl(myDb),s); 
         
         
         Vector relations = new Vector();
         
         
         dbnamex.getNewDatabaseRelations(relations); 
         dbnamex.getSessionGetDatabaseRelations(relations);
         dbnamex.getOpenDatabaseRelations(relations);
         dbnamex.getOpenByReplicaID(relations);
         dbnamex.getFormulaRelations(relations);
         dbnamex.getFrameRelations(relations);
         dbnamex.getOutlineRelations(relations, myDb);
         
	 
	 
         Display d = new Display();
         final Shell shell = new Shell(d);
         shell.setSize(700, 700);
         shell.setText("ChainDetector for LN Database");         
         shell.setImage(new Image(d, ChainDetector.class.getResourceAsStream("icon.gif")));
         LightweightSystem lws = new LightweightSystem(shell);
                                        
         ContainerFigure contents = new ContainerFigure();                  

         Font classFont = new Font(null, "Arial", 10, SWT.BOLD);
         Label classLabel1 = new Label(myDb.getTitle(), new Image(d, ChainDetector.class.getResourceAsStream("db.gif")));         
         classLabel1.setFont(classFont);
         classLabel1.setForegroundColor(ColorConstants.white);


         final UMLClassFigure classFigure = new UMLClassFigure(classLabel1);  
                  
         int x = 200;
         int y = 10;
         
         Map figuresMap = new HashMap();  
         Map labelsMap = new HashMap();
         Map attributesMap = new HashMap();
         
         Iterator it = relations.iterator ();
         while (it.hasNext ()) {
        	 Relation rel = (Relation) it.next ();
        	 //System.out.println(rel.toString());
        	 
        	 Label attribute1 = (Label) attributesMap.get(rel.getSource_location());
             if (attribute1==null){            	             
            	 attribute1 = new Label(rel.getSource_location(), new Image(d, UMLClassFigure.class.getResourceAsStream(rel.getImageName(true))));
            	 attribute1.setToolTip(new Label(rel.getSource_location()));
            	 //attribute1.setTextPlacement(attribute1.WEST);
            	 classFigure.getAttributesCompartment().add(attribute1);
            	 attributesMap.put(rel.getSource_location(), attribute1);
         	 }
             
             UMLClassFigure classFigure2;
             
             classFigure2 = (UMLClassFigure) figuresMap.get(rel.getTarget_database());
             if (classFigure2==null){
             
            	 Label classLabel2 = new Label(rel.getTarget_database(), new Image(d, ChainDetector.class.getResourceAsStream(rel.getDbImageName())));
            	 classLabel2.setFont(classFont);
            	 classLabel2.setForegroundColor(ColorConstants.white);
            	 classLabel2.setToolTip(new Label(rel.getTarget_database()));

            	 classFigure2 = new UMLClassFigure(classLabel2);                                                              
            	 classFigure2.setBounds(new Rectangle(x,y,150,20));
            	 
            	 //contentsLayout.setConstraint(classFigure2, new Rectangle(x,y,-1,-1));
            	 contents.getContentsPane().add(classFigure2);
            	 new DragFigure(classFigure2);
            	 x += 100;
                 y += 100;
            	 figuresMap.put(rel.getTarget_database(), classFigure2);
             }
             
             
             
             PolylineConnection c3 = new PolylineConnection();                              
             
             MyLabelAnchor sourceAnchor3 = new MyLabelAnchor(attribute1);                          
             
             c3.setSourceAnchor(sourceAnchor3);                                         
             
             if (rel.getLanguage()==1)
            	 c3.setForegroundColor(new Color(null,41,89,165));
             else if (rel.getLanguage()==2)
            	 c3.setForegroundColor(new Color(null,159,63,63));
             
             
             PolygonDecoration decoration = new PolygonDecoration();
             PointList decorationPointList = new PointList();
             decorationPointList.addPoint(0,0);
             decorationPointList.addPoint(-1,1);
             //decorationPointList.addPoint(-4,0);
             decorationPointList.addPoint(-1,-1);
             decoration.setTemplate(decorationPointList);
             c3.setTargetDecoration(decoration);
             
             
             if (!(rel.getTarget_element().equals(""))){                        	 
            	 
            	 Label method1 = (Label) labelsMap.get(rel.getTarget_database()+":"+rel.getTarget_element());
                 if (method1==null){

                	 method1 = new Label(rel.getTarget_element(), new Image(d, UMLClassFigure.class.getResourceAsStream(rel.getImageName(false))));
                	 method1.setToolTip(new Label(rel.getTarget_element()));
                	 classFigure2.getMethodsCompartment().add(method1);            	 
                	 Rectangle r = classFigure2.getBounds();
                	 r.height += 15;
                	 classFigure2.setBounds(r);
                	 labelsMap.put(rel.getTarget_database()+":"+rel.getTarget_element(), method1);
                	 sourceAnchor3.setTarget(method1);
                 }
            	 
            	             	 
            	 LabelAnchor targetAnchor3 = new LabelAnchor(method1);                
                 c3.setTargetAnchor(targetAnchor3);
                 c3.setConnectionRouter(new ManhattanConnectionRouter());
                 c3.setToolTip(new Label(" "+rel.getSource_location()+" ----> "+rel.getTarget_element()+" "));
            	 
            	 
             }else{
            	 ChopboxAnchor targetAnchor3 = new ChopboxAnchor(classFigure2);
                 c3.setTargetAnchor(targetAnchor3);
                 c3.setConnectionRouter(new ManhattanConnectionRouter());
                 c3.setToolTip(new Label(" "+rel.getSource_location()+" ----> Database "+rel.getTarget_database()+" "));
                 sourceAnchor3.setTarget(classFigure2);
             }
                                                   
             contents.getContentsPane().add(c3);
             
             
            
         }                                  
         
         //contentsLayout.setConstraint(classFigure, new Rectangle(10,260,-1,-1));
         classFigure.setBounds(new Rectangle(10,260,150,23+16*classFigure.getAttributesCompartment().getChildren().size()));                  
         
         contents.getContentsPane().add(classFigure);

         new DragFigure(classFigure);
         

         lws.setContents(contents);
         
         shell.open();
         while (!shell.isDisposed())
        	 while (!d.readAndDispatch())
        		 d.sleep();
	
	
     }
	 catch (Exception e)
     {
       e.printStackTrace();       
     }
     finally
     {
         NotesThread.stermThread();
     } 
	
 }
}