import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.MouseEvent;
import org.eclipse.draw2d.MouseListener;
import org.eclipse.draw2d.MouseMotionListener;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.Figure;

class DragFigure extends MouseMotionListener.Stub implements MouseListener {
    Point last;
   
    public DragFigure(IFigure figure) {
        figure.addMouseMotionListener(this);
        figure.addMouseListener(this);
    }
   
    public void mouseReleased(MouseEvent e) {
        last = null;
    }
   
    public void mouseDoubleClicked(MouseEvent e) {
    }
   
    public void mousePressed(MouseEvent e) {
        last = e.getLocation();
        e.consume();       
    }
   
    public void mouseDragged(MouseEvent e) {
        if (last == null)
        return;
       
        Point p = e.getLocation();
        Dimension delta = p.getDifference(last);
        last = p;
        Figure f = ((Figure) e.getSource());
        f.setBounds(f.getBounds().getTranslated(delta.width, delta.height));
    }
}