
public class Relation {
	String source_location;
	String target_server;
	String target_database;
	String target_element;
	int language; //1=Lotus Script, 2=Java, 3=formula
	int target_type;
	boolean target_db_fictional;
	int dxl_index;
	
	public Relation(String source_location, String target_server, String target_database, String target_element, int language, int dxl_index) {		
		this.source_location = source_location;
		this.target_server = target_server;
		this.target_database = target_database;
		this.target_element = target_element;
		this.language = language;
		this.target_type = target_type;
		this.target_db_fictional = true;
		this.dxl_index = dxl_index;
	}
		
	public String toString(){
		return source_location + ": " + target_server + ":" + target_database + ", index: " + dxl_index; 
	}

	public String getSource_location() {
		return source_location;
	}

	public String getTarget_server() {
		return target_server;
	}

	public String getTarget_database() {
		return target_database;
	}
		
	public String getTarget_element(){
		return target_element;
	}
	
	public int getLanguage(){
		return language;
	}
	
	public String getImageName(boolean source){
		String text = source_location.toLowerCase();
		if (!source) text = target_element.toLowerCase();
		
		if (text.contains("agent")) return "agent.gif";
		else if (text.contains("subform")) return "subform.gif";
		else if (text.contains("frameset")) return "frameset.gif";
		else if (text.contains("form")) return "form.gif";
		else if (text.contains("page")) return "page.gif";
		else if (text.contains("library")) return "scriptlibrary.gif";
		else if (text.contains("action")) return "action.gif";
		else if (text.contains("field")) return "field.gif";
		else if (text.contains("outline")) return "outline.gif";
		else if (text.contains("view")) return "view.gif";
		else return "field_private_obj.gif";
	}

	public void setTargetDbFictional(boolean target_db_fictional) {
		this.target_db_fictional = target_db_fictional;
	}
	
	public String getDbImageName(){
		if (target_db_fictional) return "db-inactive.gif";
		else return "db.gif";
	}
		
}
